]> git.proxmox.com Git - mirror_ubuntu-hirsute-kernel.git/blob - scripts/Kbuild.include
bpf: Fix mask direction swap upon off reg sign change
[mirror_ubuntu-hirsute-kernel.git] / scripts / Kbuild.include
1 # SPDX-License-Identifier: GPL-2.0
2 ####
3 # kbuild: Generic definitions
4
5 # Convenient variables
6 comma := ,
7 quote := "
8 squote := '
9 empty :=
10 space := $(empty) $(empty)
11 space_escape := _-_SPACE_-_
12 pound := \#
13
14 ###
15 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
16 dot-target = $(dir $@).$(notdir $@)
17
18 ###
19 # The temporary file to save gcc -MMD generated dependencies must not
20 # contain a comma
21 depfile = $(subst $(comma),_,$(dot-target).d)
22
23 ###
24 # filename of target with directory and extension stripped
25 basetarget = $(basename $(notdir $@))
26
27 ###
28 # real prerequisites without phony targets
29 real-prereqs = $(filter-out $(PHONY), $^)
30
31 ###
32 # Escape single quote for use in echo statements
33 escsq = $(subst $(squote),'\$(squote)',$1)
34
35 ###
36 # Quote a string to pass it to C files. foo => '"foo"'
37 stringify = $(squote)$(quote)$1$(quote)$(squote)
38
39 ###
40 # Easy method for doing a status message
41 kecho := :
42 quiet_kecho := echo
43 silent_kecho := :
44 kecho := $($(quiet)kecho)
45
46 ###
47 # filechk is used to check if the content of a generated file is updated.
48 # Sample usage:
49 #
50 # filechk_sample = echo $(KERNELRELEASE)
51 # version.h: FORCE
52 # $(call filechk,sample)
53 #
54 # The rule defined shall write to stdout the content of the new file.
55 # The existing file will be compared with the new one.
56 # - If no file exist it is created
57 # - If the content differ the new file is used
58 # - If they are equal no change, and no timestamp update
59 define filechk
60 $(Q)set -e; \
61 mkdir -p $(dir $@); \
62 trap "rm -f $(dot-target).tmp" EXIT; \
63 { $(filechk_$(1)); } > $(dot-target).tmp; \
64 if [ ! -r $@ ] || ! cmp -s $@ $(dot-target).tmp; then \
65 $(kecho) ' UPD $@'; \
66 mv -f $(dot-target).tmp $@; \
67 fi
68 endef
69
70 ######
71 # gcc support functions
72 # See documentation in Documentation/kbuild/makefiles.rst
73
74 # cc-cross-prefix
75 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
76 # Return first <prefix> where a <prefix>gcc is found in PATH.
77 # If no gcc found in PATH with listed prefixes return nothing
78 #
79 # Note: '2>/dev/null' is here to force Make to invoke a shell. Otherwise, it
80 # would try to directly execute the shell builtin 'command'. This workaround
81 # should be kept for a long time since this issue was fixed only after the
82 # GNU Make 4.2.1 release.
83 cc-cross-prefix = $(firstword $(foreach c, $(1), \
84 $(if $(shell command -v -- $(c)gcc 2>/dev/null), $(c))))
85
86 # output directory for tests below
87 TMPOUT = $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_$$$$
88
89 # try-run
90 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
91 # Exit code chooses option. "$$TMP" serves as a temporary file and is
92 # automatically cleaned up.
93 try-run = $(shell set -e; \
94 TMP=$(TMPOUT)/tmp; \
95 TMPO=$(TMPOUT)/tmp.o; \
96 mkdir -p $(TMPOUT); \
97 trap "rm -rf $(TMPOUT)" EXIT; \
98 if ($(1)) >/dev/null 2>&1; \
99 then echo "$(2)"; \
100 else echo "$(3)"; \
101 fi)
102
103 # as-option
104 # Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
105
106 as-option = $(call try-run,\
107 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
108
109 # as-instr
110 # Usage: cflags-y += $(call as-instr,instr,option1,option2)
111
112 as-instr = $(call try-run,\
113 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
114
115 # __cc-option
116 # Usage: MY_CFLAGS += $(call __cc-option,$(CC),$(MY_CFLAGS),-march=winchip-c6,-march=i586)
117 __cc-option = $(call try-run,\
118 $(1) -Werror $(2) $(3) -c -x c /dev/null -o "$$TMP",$(3),$(4))
119
120 # cc-option
121 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
122
123 cc-option = $(call __cc-option, $(CC),\
124 $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS),$(1),$(2))
125
126 # cc-option-yn
127 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
128 cc-option-yn = $(call try-run,\
129 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
130
131 # cc-disable-warning
132 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
133 cc-disable-warning = $(call try-run,\
134 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
135
136 # cc-ifversion
137 # Usage: EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
138 cc-ifversion = $(shell [ $(CONFIG_GCC_VERSION)0 $(1) $(2)000 ] && echo $(3) || echo $(4))
139
140 # ld-option
141 # Usage: KBUILD_LDFLAGS += $(call ld-option, -X, -Y)
142 ld-option = $(call try-run, $(LD) $(KBUILD_LDFLAGS) $(1) -v,$(1),$(2),$(3))
143
144 # ld-version
145 # Note this is mainly for HJ Lu's 3 number binutil versions
146 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
147
148 # ld-ifversion
149 # Usage: $(call ld-ifversion, -ge, 22252, y)
150 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
151
152 ######
153
154 ###
155 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
156 # Usage:
157 # $(Q)$(MAKE) $(build)=dir
158 build := -f $(srctree)/scripts/Makefile.build obj
159
160 ###
161 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
162 # Usage:
163 # $(Q)$(MAKE) $(dtbinst)=dir
164 dtbinst := -f $(srctree)/scripts/Makefile.dtbinst obj
165
166 ###
167 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
168 # Usage:
169 # $(Q)$(MAKE) $(clean)=dir
170 clean := -f $(srctree)/scripts/Makefile.clean obj
171
172 # echo command.
173 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
174 echo-cmd = $(if $($(quiet)cmd_$(1)),\
175 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
176
177 # printing commands
178 cmd = @set -e; $(echo-cmd) $(cmd_$(1))
179
180 ###
181 # if_changed - execute command if any prerequisite is newer than
182 # target, or command line has changed
183 # if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
184 # including used config symbols
185 # if_changed_rule - as if_changed but execute rule instead
186 # See Documentation/kbuild/makefiles.rst for more info
187
188 ifneq ($(KBUILD_NOCMDDEP),1)
189 # Check if both commands are the same including their order. Result is empty
190 # string if equal. User may override this check using make KBUILD_NOCMDDEP=1
191 cmd-check = $(filter-out $(subst $(space),$(space_escape),$(strip $(cmd_$@))), \
192 $(subst $(space),$(space_escape),$(strip $(cmd_$1))))
193 else
194 cmd-check = $(if $(strip $(cmd_$@)),,1)
195 endif
196
197 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
198 # (needed for make)
199 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
200 # (needed for make)
201 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
202 # (needed for the shell)
203 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
204
205 # Find any prerequisites that are newer than target or that do not exist.
206 # (This is not true for now; $? should contain any non-existent prerequisites,
207 # but it does not work as expected when .SECONDARY is present. This seems a bug
208 # of GNU Make.)
209 # PHONY targets skipped in both cases.
210 newer-prereqs = $(filter-out $(PHONY),$?)
211
212 # Execute command if command has changed or prerequisite(s) are updated.
213 if_changed = $(if $(newer-prereqs)$(cmd-check), \
214 $(cmd); \
215 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd, @:)
216
217 # Execute the command and also postprocess generated .d dependencies file.
218 if_changed_dep = $(if $(newer-prereqs)$(cmd-check),$(cmd_and_fixdep),@:)
219
220 cmd_and_fixdep = \
221 $(cmd); \
222 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).cmd;\
223 rm -f $(depfile)
224
225 # Usage: $(call if_changed_rule,foo)
226 # Will check if $(cmd_foo) or any of the prerequisites changed,
227 # and if so will execute $(rule_foo).
228 if_changed_rule = $(if $(newer-prereqs)$(cmd-check),$(rule_$(1)),@:)
229
230 ###
231 # why - tell why a target got built
232 # enabled by make V=2
233 # Output (listed in the order they are checked):
234 # (1) - due to target is PHONY
235 # (2) - due to target missing
236 # (3) - due to: file1.h file2.h
237 # (4) - due to command line change
238 # (5) - due to missing .cmd file
239 # (6) - due to target not in $(targets)
240 # (1) PHONY targets are always build
241 # (2) No target, so we better build it
242 # (3) Prerequisite is newer than target
243 # (4) The command line stored in the file named dir/.target.cmd
244 # differed from actual command line. This happens when compiler
245 # options changes
246 # (5) No dir/.target.cmd file (used to store command line)
247 # (6) No dir/.target.cmd file and target not listed in $(targets)
248 # This is a good hint that there is a bug in the kbuild file
249 ifeq ($(KBUILD_VERBOSE),2)
250 why = \
251 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
252 $(if $(wildcard $@), \
253 $(if $(newer-prereqs),- due to: $(newer-prereqs), \
254 $(if $(cmd-check), \
255 $(if $(cmd_$@),- due to command line change, \
256 $(if $(filter $@, $(targets)), \
257 - due to missing .cmd file, \
258 - due to $(notdir $@) not in $$(targets) \
259 ) \
260 ) \
261 ) \
262 ), \
263 - due to target missing \
264 ) \
265 )
266
267 echo-why = $(call escsq, $(strip $(why)))
268 endif
269
270 ###############################################################################
271 #
272 # When a Kconfig string contains a filename, it is suitable for
273 # passing to shell commands. It is surrounded by double-quotes, and
274 # any double-quotes or backslashes within it are escaped by
275 # backslashes.
276 #
277 # This is no use for dependencies or $(wildcard). We need to strip the
278 # surrounding quotes and the escaping from quotes and backslashes, and
279 # we *do* need to escape any spaces in the string. So, for example:
280 #
281 # Usage: $(eval $(call config_filename,FOO))
282 #
283 # Defines FOO_FILENAME based on the contents of the CONFIG_FOO option,
284 # transformed as described above to be suitable for use within the
285 # makefile.
286 #
287 # Also, if the filename is a relative filename and exists in the source
288 # tree but not the build tree, define FOO_SRCPREFIX as $(srctree)/ to
289 # be prefixed to *both* command invocation and dependencies.
290 #
291 # Note: We also print the filenames in the quiet_cmd_foo text, and
292 # perhaps ought to have a version specially escaped for that purpose.
293 # But it's only cosmetic, and $(patsubst "%",%,$(CONFIG_FOO)) is good
294 # enough. It'll strip the quotes in the common case where there's no
295 # space and it's a simple filename, and it'll retain the quotes when
296 # there's a space. There are some esoteric cases in which it'll print
297 # the wrong thing, but we don't really care. The actual dependencies
298 # and commands *do* get it right, with various combinations of single
299 # and double quotes, backslashes and spaces in the filenames.
300 #
301 ###############################################################################
302 #
303 define config_filename
304 ifneq ($$(CONFIG_$(1)),"")
305 $(1)_FILENAME := $$(subst \\,\,$$(subst \$$(quote),$$(quote),$$(subst $$(space_escape),\$$(space),$$(patsubst "%",%,$$(subst $$(space),$$(space_escape),$$(CONFIG_$(1)))))))
306 ifneq ($$(patsubst /%,%,$$(firstword $$($(1)_FILENAME))),$$(firstword $$($(1)_FILENAME)))
307 else
308 ifeq ($$(wildcard $$($(1)_FILENAME)),)
309 ifneq ($$(wildcard $$(srctree)/$$($(1)_FILENAME)),)
310 $(1)_SRCPREFIX := $(srctree)/
311 endif
312 endif
313 endif
314 endif
315 endef
316 #
317 ###############################################################################
318
319 # delete partially updated (i.e. corrupted) files on error
320 .DELETE_ON_ERROR:
321
322 # do not delete intermediate files automatically
323 .SECONDARY: